#include <stdlib.h>
#include <math.h>

typedef struct ViCToR 
{
	float x;
	float y;
	float z;
	float t;
} ViCToR;

//========================================================================
//=======================primitive========================================
//========================================================================

ViCToR * ViCToR_create(ViCToR * ViCToR_a)
{
	if (ViCToR_a == NULL)
	{
		ViCToR_a = malloc(sizeof(ViCToR));
	}
	return ViCToR_a;
}

ViCToR * ViCToR_delete(ViCToR * ViCToR_a)
{
	if (ViCToR_a != NULL)
	{
		free(ViCToR_a);
		return NULL;
	}
	return ViCToR_a;
}

ViCToR * ViCToR_set(ViCToR * ViCToR_a, float ViCToR_x, float ViCToR_y) 
{
	ViCToR_a->x = ViCToR_x;
	ViCToR_a->y = ViCToR_y;
	//ViCToR_a->z = ViCToR_z;
	//ViCToR_a->t = ViCToR_t;
	return ViCToR_a;
}

ViCToR * ViCToR_cpy(ViCToR * ViCToR_a, ViCToR * ViCToR_b)
	/*	mov va,vb	*/
{
	ViCToR_a->x = ViCToR_b->x;
	ViCToR_a->y = ViCToR_b->y;
	//ViCToR_a->z = ViCToR_b->z;
	//ViCToR_a->t = ViCToR_b->t;
	return ViCToR_a;
}

//========================================================================
//========================math============================================
//========================================================================

ViCToR * ViCToR_sub(ViCToR * ViCToR_a, ViCToR * ViCToR_b, ViCToR * ViCToR_c)
	/*	sub va,vb	*/
{
	ViCToR_c->x = ViCToR_a->x - ViCToR_b->x;          
	ViCToR_c->y = ViCToR_a->y - ViCToR_b->y;
	//ViCToR_c->z = ViCToR_a->z - ViCToR_b->z;
	//ViCToR_c->t = ViCToR_a->t - ViCToR_b->t;
	return ViCToR_c;
}

ViCToR * ViCToR_add(ViCToR * ViCToR_a, ViCToR * ViCToR_b, ViCToR * ViCToR_c)
	/*	add va,vb	*/
{
	ViCToR_c->x = ViCToR_a->x + ViCToR_b->x;         
	ViCToR_c->y = ViCToR_a->y + ViCToR_b->y;
	//ViCToR_c->z = ViCToR_a->z + ViCToR_b->z;         
	//ViCToR_c->t = ViCToR_a->t + ViCToR_b->t;
	return ViCToR_c;
}

ViCToR * ViCToR_mul(ViCToR * ViCToR_a, ViCToR * ViCToR_b, ViCToR * ViCToR_c)
	/*	mul va,vb	*/
{
 	ViCToR_c->x = ViCToR_a->x * ViCToR_b->x;         
	ViCToR_c->y = ViCToR_a->y * ViCToR_b->y;
	//ViCToR_c->z = ViCToR_a->z * ViCToR_b->z;         
	//ViCToR_c->t = ViCToR_a->t * ViCToR_b->t;
	return ViCToR_c;
}

ViCToR * ViCToR_div(ViCToR * ViCToR_a, ViCToR * ViCToR_b, ViCToR * ViCToR_c)
	/*	div va,vb	*/
{
	ViCToR_c->x = ViCToR_a->x / ViCToR_b->x;
	ViCToR_c->y = ViCToR_a->y / ViCToR_b->y;
	//ViCToR_c->z = ViCToR_a->z / ViCToR_b->z;         
	//ViCToR_c->t = ViCToR_a->t / ViCToR_b->t;
	return ViCToR_c;
}

ViCToR * ViCToR_neg(ViCToR * ViCToR_a, ViCToR * ViCToR_c)
	/*	-va	*/
{
	ViCToR_c->x = 0-ViCToR_a->x;                 
	ViCToR_c->y = 0-ViCToR_a->y;
	//ViCToR_c->z = 0-ViCToR_a->z;                 
	//ViCToR_c->t = 0-ViCToR_a->t;
	return ViCToR_c;
}

//========================================================================
//=======================trigonometrie=2d=================================
//========================================================================

ViCToR * ViCToR_sqr(ViCToR * ViCToR_a, ViCToR * ViCToR_c)
{
	return (ViCToR_mul(ViCToR_a, ViCToR_a, ViCToR_c));
}

ViCToR * ViCToR_delta(ViCToR * ViCToR_a, ViCToR * ViCToR_b, ViCToR * ViCToR_c)
{
	return ( ViCToR_sub( ViCToR_a, ViCToR_b, ViCToR_c));
}

ViCToR * ViCToR_dist(ViCToR * ViCToR_a, ViCToR * ViCToR_b, ViCToR * ViCToR_c)
{
	return ( ViCToR_sqr( ViCToR_sub( ViCToR_a, ViCToR_b, ViCToR_c),ViCToR_c));
}

ViCToR * ViCToR_hypothenuse(ViCToR * ViCToR_a, ViCToR * ViCToR_c)
{
	ViCToR_c = ViCToR_sqr(ViCToR_a,ViCToR_c);
	ViCToR_c->t = sqrt(ViCToR_c->x + ViCToR_c->y);
	return ViCToR_c;
}

ViCToR * ViCToR_trigo(ViCToR * ViCToR_a, ViCToR * ViCToR_c)
{
	ViCToR_c = ViCToR_hypothenuse(ViCToR_a,ViCToR_c);
	ViCToR_c->x = ViCToR_c->x / ViCToR_c->t;
	ViCToR_c->y = ViCToR_c->y / ViCToR_c->t;
	return ViCToR_c;
}

//==========================================================================
